#ifndef _lf_xbar32_h_
#define _lf_xbar32_h_

/*
 * Hardware-specific struct for a tagged xbar
 */

/* magic route byte for querying a tagged xbar */
#define LF_TAGGED_XBAR_QUERY_ROUTE 0xA0

/*
 * This struct must start 4 bytes into a message and be clear to zero
 * for CRC to be computed properly
 */
struct lf_tagged_xbar_insert {
  uint32_t id;
  uint8_t absolute_port;
  uint8_t quadrant_enabled;
  uint16_t pad0;
  uint32_t status_mask;
  uint32_t pad1;
  uint32_t crc32;
};

#endif /* _lf_xbar32_h_ */
