/*************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET          *
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the       *
 * "License"); User may not use this file except in compliance with the  *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2004 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

#ifndef MX__LIB_H
# define MX__LIB_H

void mx__luigi(struct mx_endpoint *ep);
void mx__nic_id_to_macaddr(uint64_t nic_id, uint8_t macaddr[6]);
void mx__macaddr_to_nic_id(uint8_t macaddr[6], uint64_t *nic_id);
void mx__finish_buffered_requests(struct mx_endpoint *ep);
MX__THREAD_RETURN_T mx__progress(void *p);
union mx_request;
int mx__queue_large_recv(struct mx_endpoint *ep, union mx_request *r);
void mx__post_send(struct mx_endpoint *ep, union mx_request *q,
		   mcp_ureq_t *req, uint16_t mcp_handle);
void mx__recv_complete(struct mx_endpoint *ep, union mx_request *r, 
		       mx_status_code_t status);
void mx__send_complete(mx_endpoint_t ep, union mx_request *r,
		       mx_status_code_t status);

void mx_rdmawin_finalize(struct mx_endpoint *ep);
void mx_rdmawin_init(struct mx_endpoint *ep);

void mx__process_early(mx_endpoint_t ep, struct mx__partner *partner);

MX_FUNC(const char *) mx__nic_id_to_str(char *str, uint64_t nic_id, uint32_t len);

extern struct mx__opt {
  uint8_t monothread;
  uint8_t verbose;
  uint8_t verbose_errors;
  uint8_t errors_are_fatal;
  uint8_t sigusr1_handler;
  uint8_t disable_self;
  uint8_t disable_shmem;
  uint8_t rcache;
  uint8_t coredump;
  uint8_t abort_sleeps;
  uint8_t no_myrinet;
  uint8_t csum;
  uint8_t wc_fence;
} mx__opt;

#endif /* MX_LIB_H */
