/*************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET          *
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the       *
 * "License"); User may not use this file except in compliance with the  *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2004 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

#ifndef MX__PARTNER_H
#define MX__PARTNER_H

#define MX__QUADRANT(seq) (((seq) >> 12) & 3)
#define MX__SEQNO(seq) ((seq) & 0x3fff)
#define MX__SESNO(seq) ((seq) & 0xc000)
#define MX__SESNO_ONE 0x4000
#define MX__QUADRANT_ONE 0x1000

/* negative if msg has already been seen,
   zero if msg is the current expected one,
   positive if msg is early */
static inline int16_t
mx__msg_order(uint16_t msg_seq, uint16_t cur_seq)
{
  if (msg_seq == cur_seq)
    return 0;
  return ((int16_t)(msg_seq - cur_seq) << 2) | (MX__SESNO(msg_seq ^ cur_seq)? (int16_t)-1 : (int16_t)0);
}

struct mx__early *mx__partner_insert_early(struct mx__partner *partner,
					   mcp_uevt_recv_t *xyz,
					   uint16_t msg_seq,
					   mx__process_recv_t recv_func,
					   uint8_t type, char *data);

void mx__partner_cleanup(struct mx_endpoint *ep, struct mx__partner *partner);

struct mx__partner * mx__partner_create(struct mx_endpoint *ep, uint16_t peer_index, uint16_t endpt);

#endif
