/*************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET          *
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the       *
 * "License"); User may not use this file except in compliance with the  *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2004 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

static const char __idstring[] = "@(#)$Id: mx__request.c,v 1.7 2005/06/29 00:23:15 eugene Exp $";

#include "mx_auto_config.h"
#include "myriexpress.h"
#include "mx__lib_types.h"
#include "mx__request.h"

/* 0 - success */
int mx__rl_init(struct mx__request_lookaside *rl)
{
  rl->r = mx__rl__alloc();
  if (rl->r == NULL) {
    return -1;
  }
  rl->count = REQ_CHUNK-1;
  rl->free_req = &rl->r[1];
  rl->alloc_count = rl->count;
  return 0;
}

void mx__rl_fini(struct mx__request_lookaside *rl)
{
  union mx_request *r;

  r = rl->r;
  while (r != NULL) {
    rl->r = rl->r->basic.next;
    mx_free(r);
    r = rl->r;
  }
}

