/*************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET          *
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the       *
 * "License"); User may not use this file except in compliance with the  *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2004 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

static const char __idstring[] = "@(#)$Id: mx_ipeek.c,v 1.22 2005/08/08 22:49:39 eugene Exp $";

#include "mx_auto_config.h"
#include "myriexpress.h"
#include "mx__lib_types.h"
#include "mx__lib.h"
#include "mx__request.h"

int
mx__ipeek_common(mx_endpoint_t endpoint, mx_request_t *request);

MX_FUNC(mx_return_t)
mx_ipeek(mx_endpoint_t endpoint, mx_request_t *request,
	 uint32_t *result)
{
  /* TODO: Make sure endpoint is valid? */
  MX__MUTEX_LOCK(&endpoint->lock);
  *result = mx__ipeek_common(endpoint, request);
  MX__MUTEX_UNLOCK(&endpoint->lock);
  return MX_SUCCESS;
}

int mx__ipeek_common(mx_endpoint_t endpoint, mx_request_t *request)
{
  union mx_request *r;
  int result = 0;
  mx__luigi(endpoint);
  if (!mx__isempty_request(&endpoint->doneq)) {
    r = mx__head_request(&endpoint->doneq);
    *request = (mx_request_t)r;
    result = 1;
  }
  else {
    *request = NULL;
  }
  return result;
}
