/*************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET          *
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the       *
 * "License"); User may not use this file except in compliance with the  *
 * License.  The full text of the License can found in LICENSE.TXT       *
 *                                                                       *
 * Software distributed under the License is distributed on an "AS IS"   *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See  *
 * the License for the specific language governing rights and            *
 * limitations under the License.                                        *
 *                                                                       *
 * Copyright 2003 - 2004 by Myricom, Inc.  All rights reserved.          *
 *************************************************************************/

static const char __idstring[] = "@(#)$Id: mx_peek.c,v 1.24 2005/08/08 22:49:39 eugene Exp $";

#include "mx_auto_config.h"
#include "myriexpress.h"
#include "mx__lib_types.h"
#include "mx__request.h"
#include "mx__error.h"
#include "mx__sleep.h"

int
mx__ipeek_common(mx_endpoint_t endpoint, mx_request_t *request);

MX_FUNC(mx_return_t)
mx_peek(mx_endpoint_t endpoint, uint32_t timeout, mx_request_t *request,
	uint32_t *result)
{
  union mx_request *r = NULL;
  union mx_request *peek_request;

  /* TODO: This whole thing is pretty convoluted. Find a cleaner way to
     express this */
  MX__MUTEX_LOCK(&endpoint->lock);
  /* Go through one iteration of mx__ipeek_common to see if a request 
     is already done. */
  *result = mx__ipeek_common(endpoint, request);
  if (*result == 0) {
    peek_request = mx__rl_alloc(&endpoint->req_lookaside);
    endpoint->peek_count++;
    if (peek_request == NULL) {
      MX__MUTEX_UNLOCK(&endpoint->lock);
      return mx__error(endpoint, "mx_peek", MX_NO_RESOURCES);
    }
    peek_request->basic.status.context = NULL;
    peek_request->basic.wait_state = MX__WAIT_STATE_WAITING;
    mx__sleep_on_request(endpoint, peek_request, timeout, &endpoint->peek_waiters, &endpoint->peekq);
    r = peek_request->basic.status.context;
    if (r != NULL) {
      *request = r;
      *result = 1;
    }
    else {
      *result = 0;
    }
    endpoint->peek_count--;
    mx__rl_free(&endpoint->req_lookaside, peek_request);
  }
  MX__MUTEX_UNLOCK(&endpoint->lock);
  return MX_SUCCESS;
}
